using UnityEngine;
using System.Collections;
using Leap;

public class Leap3DViewer : MonoBehaviour {
	
	Controller m_leapController;
	float m_zoomSpeed = 5.0f;
	// Use this for initialization
	void Start () {
		m_leapController = new Controller();
	}
	
	// Update is called once per frame
	void Update () {
		Frame frame = m_leapController.Frame();
		
		// rotating the planet.
		if (frame.Fingers.Count > 3) {
			for (int i = 0; i < frame.Hands.Count; ++i) {
				// engagement zone
				if (frame.Hands[i].PalmPosition.ToUnityScaled().z > -1.0f) {
					if (Mathf.Abs(frame.Hands[i].PalmVelocity.ToUnityScaled().x) > 8.0f) {
						rigidbody.angularDrag = 1.0f;
						rigidbody.AddTorque(new Vector3(0, -(frame.Hands[i].PalmVelocity.ToUnityScaled().x), 0));
					} else {
						rigidbody.angularDrag = 2.0f;
					}
				}
			}
		}
		
		Vector3 camToObj = transform.position - Camera.main.transform.position;
		// zooming
		if (frame.Hands.Count == 2 && frame.Fingers.Count < 3) {
			Hand left = frame.Hands[0];
			Hand right = frame.Hands[1];
			if (left.PalmPosition.x > right.PalmPosition.x) {
				left = right;
				right = frame.Hands[0];
			}
			
			Camera.main.rigidbody.drag = 5.0f;
			
			// pull, so zoom in.
			if(left.PalmVelocity.ToUnityScaled().x < -3.0f && right.PalmVelocity.ToUnityScaled().x > 3.0f) {
				Camera.main.rigidbody.velocity = camToObj.normalized * m_zoomSpeed;
				Camera.main.rigidbody.drag = 2.0f;
			}
			
			// push, so zoom out.
			if (left.PalmVelocity.ToUnityScaled().x > 3.0f && right.PalmVelocity.ToUnityScaled().x < -3.0f) {
				Camera.main.rigidbody.velocity = -camToObj.normalized * m_zoomSpeed;
				Camera.main.rigidbody.drag = 2.0f;
			}
		}
		
		// apply zoom constraints
		if (camToObj.magnitude < 3.3f && Vector3.Dot(Camera.main.rigidbody.velocity, camToObj) > 0) {
			Camera.main.rigidbody.velocity = Vector3.zero;
		}
		
	}
}
